import sys
from operator import *

class AnalizzaLibro:
	def __init__(self,fileName):
		self.fName=fileName
		self.gls=[]
	
	def readFile(self):
		if self.fName=='' or self.fName==None:
			raise RuntimeError
		try:
			sf=open(self.fName,'r')
		except IOError:
			print "Errore nell'apertura del file"
			sys.exit(1)
		tmp=sf.readlines()
		for i in tmp:
			t = i.split()
			#Non rimuove punti alla fine della parola, viene lasciato come esercizio
			self.gls.extend(t)
		print "File letto con successo!"
		
	def LongerWords(self):
		if len(self.gls)==0:
			raise RuntimeError
		diz={}
		for i in self.gls:
			if len(i)>5:
				if i not in diz:
					diz[i]=1
				else:
					diz[i]=diz[i]+1
		tmp=[]
		for i,j in diz.items():
			if j>10:
				tmp.append(i)
		tmp.sort(key=len)
		return tmp

	def SortedWords(self):
		if len(self.gls)==0:
			raise RuntimeError
		tmp=sorted(self.gls)
		diz={}
		for i in tmp:
			if len(i)>8:
				if len(i) not in diz:
					l=[i]
					diz[len(i)]=l
				else:
					if i not in diz[len(i)]:
						diz[len(i)].append(i)
		return sorted(diz.values(),reverse=True)

if __name__=="__main__":
	nFile=raw_input("Inserisci il nome del file da analizzare> ")
	al=AnalizzaLibro(nFile)
	al.readFile()
	try:
		lWords=al.LongerWords()
		sWords= al.SortedWords()
		
		print "\nLe parole piu' lunghe di 5 caratteri ordinate per lunghezza sono:"
		for i in  lWords:
			print "%s\t" %i,
		print "\n"
		print "\nLe parole, in ordine lessicografico, piu' lunghe di 8 caratteri raggruppate per lughezza sono:"
		
		for i in sWords:
			print "Lunghezza %d" %len(i[0])
			for j in  i:
				print "%s\t" %j,
			print "\n"
	except RuntimeError:
		print "Errore nel nome del file"
		sys.exit(1)

